define("ballooniesIXFBackgroundPort", ["componentmodelComponentApi", "gameLayoutApi", "clientkernelEventbusApi"],
    function(componentmodelComponentApi, gameLayoutApi, clientkernelEventbusApi) {
        "use strict";

        function $iterator(o) {
            if (o instanceof Array) return function() {
                return {
                    cur: 0,
                    arr: o,
                    hasNext: function() {
                        return this.cur < this.arr.length;
                    },
                    next: function() {
                        return this.arr[this.cur++];
                    }
                };
            };
            return typeof(o.iterator) == 'function' ? $bind(o, o.iterator) : o.iterator;
        };;
        var $fid = 0;

        function $bind(o, m) {
            if (m == null) return null;
            if (m.__id__ == null) m.__id__ = $fid++;
            var f;
            if (o.hx__closures__ == null) o.hx__closures__ = {};
            else f = o.hx__closures__[m.__id__];
            if (f == null) {
                f = function() {
                    return f.method.apply(f.scope, arguments);
                };
                f.scope = o;
                f.method = m;
                o.hx__closures__[m.__id__] = f;
            }
            return f;
        };
        var $_;
        var $estr = function() {
            return _hcmn_.js_Boot.__string_rec(this, '');
        };
        if (typeof ballooniesIXFBackgroundPort == 'undefined') {
            var ballooniesIXFBackgroundPort = {};
        };
        ballooniesIXFBackgroundPort.BackgroundDeclaration = function() {};
        ballooniesIXFBackgroundPort.BackgroundDeclaration = ck_implements(ballooniesIXFBackgroundPort.BackgroundDeclaration, componentmodelComponentApi.IComponentDeclaration);
        ballooniesIXFBackgroundPort.BackgroundDeclaration.__interfaces__ = [componentmodelComponentApi.IComponentDeclaration];
        ballooniesIXFBackgroundPort.BackgroundDeclaration.__name__ = ["ballooniesIXFBackgroundPort", "BackgroundDeclaration"];
        ballooniesIXFBackgroundPort.BackgroundDeclaration.prototype.getChildComponents = function() {
            return null;
        };
        ballooniesIXFBackgroundPort.BackgroundDeclaration.prototype.getReferredComponents = function() {
            return null;
        };
        ballooniesIXFBackgroundPort.BackgroundDeclaration.prototype.getImplementedPorts = function() {
            return [ballooniesIXFBackgroundPort.IBackgroundImplementationPort];
        };
        ballooniesIXFBackgroundPort.BackgroundDeclaration.prototype.getUsedPorts = function() {
            return [gameLayoutApi.IGameLayoutPort];
        };
        ballooniesIXFBackgroundPort.BackgroundDeclaration.prototype.__class__ = ballooniesIXFBackgroundPort.BackgroundDeclaration;

        ballooniesIXFBackgroundPort.IBackgroundPort = function() {}
        ballooniesIXFBackgroundPort.IBackgroundPort.prototype = {

            getChange: function() {
                return {
                    arguments: [],
                    returns: "*"
                };
            },
            getChanged: function() {
                return {
                    arguments: [],
                    returns: "*"
                };
            },
            prepareBackground: function() {
                return {
                    arguments: [],
                    returns: "*"
                };
            }
        };

        ballooniesIXFBackgroundPort.IBackgroundImplementationPort = function() {}
        ballooniesIXFBackgroundPort.IBackgroundImplementationPort.prototype = {

            getChange: function() {
                return {
                    arguments: [],
                    returns: "*"
                };
            },
            getChanged: function() {
                return {
                    arguments: [],
                    returns: "*"
                };
            },
            prepareBackground: function() {
                return {
                    arguments: [],
                    returns: "*"
                };
            }
        };
        ballooniesIXFBackgroundPort.BackgroundPort = function(bus) {
            this.prepareBgd = new clientkernelEventbusApi.Topic("background:prepare");
            this.changed = new clientkernelEventbusApi.Topic("background:changed");
            this.change = new clientkernelEventbusApi.Topic("background:change");
            this.change.connect(bus);
            this.changed.connect(bus);
            this.prepareBgd.connect(bus);
        };
        ballooniesIXFBackgroundPort.BackgroundPort = ck_implements(ballooniesIXFBackgroundPort.BackgroundPort, ballooniesIXFBackgroundPort.IBackgroundPort);
        ballooniesIXFBackgroundPort.BackgroundPort = ck_implements(ballooniesIXFBackgroundPort.BackgroundPort, ballooniesIXFBackgroundPort.IBackgroundImplementationPort);
        ballooniesIXFBackgroundPort.BackgroundPort.__interfaces__ = [ballooniesIXFBackgroundPort.IBackgroundPort, ballooniesIXFBackgroundPort.IBackgroundImplementationPort];
        ballooniesIXFBackgroundPort.BackgroundPort.__name__ = ["ballooniesIXFBackgroundPort", "BackgroundPort"];
        ballooniesIXFBackgroundPort.BackgroundPort.prototype.change = null;
        ballooniesIXFBackgroundPort.BackgroundPort.prototype.changed = null;
        ballooniesIXFBackgroundPort.BackgroundPort.prototype.prepareBgd = null;
        ballooniesIXFBackgroundPort.BackgroundPort.prototype.getChange = function() {
            return this.change;
        };
        ballooniesIXFBackgroundPort.BackgroundPort.prototype.getChanged = function() {
            return this.changed;
        };
        ballooniesIXFBackgroundPort.BackgroundPort.prototype.prepareBackground = function() {
            return this.prepareBgd;
        };
        ballooniesIXFBackgroundPort.BackgroundPort.prototype.__class__ = ballooniesIXFBackgroundPort.BackgroundPort;
        ballooniesIXFBackgroundPort.BackgroundPortFactory = function() {};
        ballooniesIXFBackgroundPort.BackgroundPortFactory = ck_implements(ballooniesIXFBackgroundPort.BackgroundPortFactory, componentmodelComponentApi.IPortFactory);
        ballooniesIXFBackgroundPort.BackgroundPortFactory.__interfaces__ = [componentmodelComponentApi.IPortFactory];
        ballooniesIXFBackgroundPort.BackgroundPortFactory.__name__ = ["ballooniesIXFBackgroundPort", "BackgroundPortFactory"];
        ballooniesIXFBackgroundPort.BackgroundPortFactory.prototype.provide = function(channel) {
            return new ballooniesIXFBackgroundPort.BackgroundPort(channel);
        };
        ballooniesIXFBackgroundPort.BackgroundPortFactory.prototype["use"] = function(channel) {
            return new ballooniesIXFBackgroundPort.BackgroundPort(channel);
        };
        ballooniesIXFBackgroundPort.BackgroundPortFactory.prototype.__class__ = ballooniesIXFBackgroundPort.BackgroundPortFactory;
        ballooniesIXFBackgroundPort.ChangeBackgroundPayload = function(imageNo, fade) {
            if (fade == null) fade = true;
            this.imageNo = imageNo;
            this.fade = fade;
        };
        ballooniesIXFBackgroundPort.ChangeBackgroundPayload.__name__ = ["ballooniesIXFBackgroundPort", "ChangeBackgroundPayload"];
        ballooniesIXFBackgroundPort.ChangeBackgroundPayload.prototype.imageNo = null;
        ballooniesIXFBackgroundPort.ChangeBackgroundPayload.prototype.fade = null;
        ballooniesIXFBackgroundPort.ChangeBackgroundPayload.prototype.__class__ = ballooniesIXFBackgroundPort.ChangeBackgroundPayload;
        if (typeof haxe == 'undefined') {
            var haxe = {};
        };

        haxe.IMap = function() {}
        haxe.IMap.prototype = {

        };
        return {
            exports: ballooniesIXFBackgroundPort
        };
    });
//# sourceURL=ballooniesIxfBackgroundPort.js